﻿using FarPoint.Win;
using FarPoint.Win.Spread.CellType;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ComboBoxEvents
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            InitSpread();
        }

        private void InitSpread()
        {
            ComboBoxCellType comboCell1 = new ComboBoxCellType();
            comboCell1.Items = new string[] { "1", "2", "3", "4" };

            fpSpread1.ActiveSheet.Cells[2, 2].CellType = comboCell1;

            ComboBoxCellType comboCell2 = new ComboBoxCellType();
            comboCell2.Items = new string[] { "One", "Two", "Three", "Four" };

            fpSpread1.ActiveSheet.Cells[6, 2].CellType = comboCell2;

            fpSpread1.ComboCloseUp += FpSpread1_ComboCloseUp;
        }

        private void FpSpread1_ComboCloseUp(object sender, FarPoint.Win.Spread.EditorNotifyEventArgs e)
        {
            if (e.Row == 2 && e.Column == 2)
            {
                ComboBoxCellType comboCell =  fpSpread1.ActiveSheet.GetEditor(6, 2) as ComboBoxCellType;
                var editor = comboCell.GetEditorControl(new FarPoint.Win.Spread.Appearance(), fpSpread1.ZoomFactor);

                var comboCloseUpMethod = fpSpread1.GetType().GetMethods(System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance)
                    .Where(m => m.Name == "OnComboCloseUp").FirstOrDefault();
                comboCloseUpMethod?.Invoke(fpSpread1, new object[] { new FarPoint.Win.Spread.EditorNotifyEventArgs(e.View, editor, 6, 2) });

            }
            if (e.Row == 6 && e.Column == 2)
            {
                Console.WriteLine("ComboCloseUp for 2nd Combo");
            }
        }
    }
}
